//FarbeZuGrau_Werte_402d.js
// 03.06.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Farbfelder in Graustufen umwandeln

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prfen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// das Dokument im Vordergrund
var curDoc = app.documents[0];

// "Gelb" und "Schwarz" je nach Sprache
if ((app.locale)*1 == 1279477362) { // franzsisches InDesign
	var yChar = "J";
	var kChar = "N";
}
else {
	var yChar = "Y";
	var kChar = "K";
}

// die Namen der Farben und deren Anzahl speichern
var allNames  = curDoc.swatches.everyItem().name;
var nSwatches = allNames.length;
var ctr = 0;

// eine Schleife durch die Farbfelder
for (var s=0; s<nSwatches; s++) {
	var colName = allNames[s];
	if (colName != "None" && colName != "Registration" && colName != "Paper" && colName != "Black") {
		// das aktuelle Farbobjekt
		var curColor = curDoc.colors.itemByName(colName);
		// eine Einmal-Schleife
		for (var x=0; x<1; x++) {
			// nach CMYK konvertieren
			try {
				curColor.space = ColorSpace.CMYK;
				// den eventuell genderten Namen speichern ...
				colNameMod = curDoc.swatches[ctr].name;
				// ... und das Objekt neu zuweisen
				curColor = curDoc.colors.itemByName(colNameMod);
			}
			catch (e) {
				ctr++;
				break;
			}
			// die CMYK-Werte prfen
			var tmpVals = curColor.colorValue;
			var c = tmpVals[0];
			var m = tmpVals[1];
			var y = tmpVals[2];
			var k = tmpVals[3];
			// wenn das Total der Anteile CMY grsser ist als Null
			if (c+m+y > 0) {
				// die Zusammensetzung ermitteln
				var comp = 0;
				if (c>0) { comp = comp+ 2; }
				if (m>0) { comp = comp+ 4; }
				if (y>0) { comp = comp+ 8; }
				if (k>0) { comp = comp+16;}
				// den Schwarzanteil ausrechnen
				if      (comp ==  2) { gray = (c*0.5); }
				else if (comp ==  4) { gray = (m*0.5); }
				else if (comp ==  6) { gray = (c*0.45)+(m*0.45); }
				else if (comp ==  8) { gray = (y*0.25); }
				else if (comp == 10) { gray = (c*0.45)+(y*0.25); }
				else if (comp == 12) { gray = (m*0.45)+(y*0.25); }
				else if (comp == 14) { gray = (c*0.4)+(m*0.4)+(y*0.25); }
				else if (comp == 18) { gray = (c*0.5)+(k); }
				else if (comp == 20) { gray = (m*0.5)+(k); }
				else if (comp == 22) { gray = (c*0.45)+(m*0.45)+(k); }
				else if (comp == 24) { gray = (y*0.25)+(k); }
				else if (comp == 26) { gray = (c*0.4)+(y*0.2)+(k*0.8); }
				else if (comp == 28) { gray = (m*0.4)+(y*0.2)+(k*0.8); }
				else if (comp == 30) { gray = (c*0.35)+(m*0.35)+(y*0.2)+(k*0.8); }
				// abrunden, falls notwendig
				var kVal = Math.floor(gray);
				// wenn hher als 100
				if (kVal>100) {
					kVal = 100;
				}
				// den neuen Namen zusammensetzen
				var newName = "C=0 M=0 " + yChar + "=0 " + kChar + "=" + kVal;
				var newVals = [0,0,0,kVal];
				// testen, ob der neue Farbfeldname schon existiert
				try {
					testColor = curDoc.swatches.itemByName(newName).name;
					// wenn ja, dann der Variablen die existierende Farbe zuweisen
					newColor  = curDoc.swatches.itemByName(newName);
				}
				catch (e) {
					// sonst ein neues Farbfeld erzeugen
					newColor  = curDoc.colors.add();
					newColor.model = ColorModel.PROCESS;
					newColor.space = ColorSpace.CMYK;
					newColor.name  = newName;
					newColor.colorValue = newVals;
				}
				// das aktuelle Farbfeld entfernen und es durch das neue ersetzen
				try {
					curDoc.swatches.itemByName(colNameMod).remove(curDoc.swatches.itemByName(newColor.name));
				}
				catch (e) {
					ctr++;
				}
			}
			else {
				ctr++;
			}
		}
	}
	else {
		ctr++;
	}
}

// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(999);
// das Fenster schliessen
dlog.close();